#include <iostream>
#include <fstream>
#include <bitset>

using namespace std;

ifstream source;
fstream output;

//0x21 0xFF 0x01 0xF9 0x3E 0x01 0xD3 0x00 0xC3 0x04 0x00 
int main()
{
   cout << "FLASH code generator v1.0\nby Leoneq ;3\n" ;
   source.open("ROM.bin", ios::binary | ios::ate);
   if(source.good()) cout << "Successfully opened the file.\n";
   else cout << "Couldn't open the file. Put 'ROM.bin' in the same directory where .exe is.";
   int size = source.tellg();
   source.close();
   source.open("ROM.bin", ios::binary);
   char buffer[size];
   source.read (buffer, size);
   source.close();
   output.open("array.txt", ios::out);
   output << "//generated data\nconst byte data[" << size << "] = {";
   for(int i = 0; i < (size-1); i++) 
      output << "B" << bitset<8> (buffer[i]) << ", ";
   output <<"B" << bitset<8> (buffer[size]) << "};";
   cout << "The array is in 'array.txt'. Exit...";
   return 0;
}